package org.semanticweb.glp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import org.semanticweb.lp.Term;

/**
 *  Title: Triple Description: RDF Query and Inference Language Copyright:
 *  Copyright (c) 2001 Company: Stanford University
 *
 *@author     Stefan Decker
 *@created    January 17, 2002
 *@version    1.0
 */

public abstract class GLPTerm extends GLPExpression {

    /**
     *  Description of the Method
     *
     *@param  h  Description of the Parameter
     *@return    Description of the Return Value
     */
    public abstract GLPTerm copyTerm(HashMap h);


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public abstract GLPTerm copyTerm();


    public abstract Term toLPTerm();


    /**
     *  Description of the Method
     *
     *@param  free   Description of the Parameter
     *@param  bound  Description of the Parameter
     */
    public abstract void freeBoundVariables(HashSet free, HashSet bound);

}
