package org.semanticweb.triple.inference.builtins;
import java.lang.*;
import java.util.*;
import org.semanticweb.triple.inference.Atom;
import org.semanticweb.triple.inference.Term;
import org.semanticweb.triple.inference.BuiltinFunc;
import org.semanticweb.triple.inference.NumTerm;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class lives extends BuiltinFunc {
    static Hashtable Ht = new Hashtable();
    static lives instance = null;


    /**
     *  Constructor for the lives object
     */
    public lives() {
        instance = this;
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void add(Atom t) {
        Vector v;
        v = (Vector) Ht.get(t.terms[0].toString());
        if (v == null) {
            v = new Vector();
            Ht.put(t.terms[0].toString(), v);
        }
        v.addElement(t);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean available(Atom t) {
        Atom st;
        Atom et;
        st = (Atom) starts.Ht.get(t.terms[0].toString());
        et = (Atom) ends.Ht.get(t.terms[0].toString());
        if ((st != null) && (et != null)) {
            return true;
        }
        else {
            return false;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void eval(Atom t) {
        instance = this;
        if (!available(t) || ok(t)) {
            add(t);
            insert(t);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean evaluable(Atom t) {
        if (t.terms[0].ground && (t.terms[1] instanceof NumTerm)) {
            return true;
        }
        else {
            return false;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean ok(Atom t) {
        Atom st;
        Atom et;
        st = (Atom) starts.Ht.get(t.terms[0].toString());
        et = (Atom) ends.Ht.get(t.terms[0].toString());
        if ((st != null) && (et != null)) {
            if ((((NumTerm) st.terms[1]).zahl <= ((NumTerm) t.terms[1]).zahl) &&
                    (((NumTerm) t.terms[1]).zahl <= ((NumTerm) et.terms[1]).zahl)) {
                return true;
            }
        }
        return false;
    }


    /**
     *  Description of the Method
     *
     *@param  T  Description of the Parameter
     */
    public void reeval(Term T) {

//System.out.println("Reeval"); T.print(System.out); System.out.println();
        java.util.Enumeration enm;
        Atom t;
        Vector v = (Vector) Ht.get(T.toString());
        if (v != null) {
            for (enm = v.elements(); enm.hasMoreElements(); ) {
                t = (Atom) enm.nextElement();
//System.out.println("examine"); t.print(System.out); System.out.println();
                if (available(t) && !ok(t)) {
                    retract(t);
                    //System.out.println("retract");
                }
            }
        }

    }
}
