/*
 * ExistsFormula.java
 *
 * Created on January 29, 2002, 1:10 PM
 */

package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


/**
 *
 * @author  Michael Sintek
 * @version 
 */
public class ExistsFormula extends QuantifierFormula {

  public String toString (Syntax syntax) {
    return toString("exists", syntax); // from QuantifierFormula
  }
  
  public GLogicFormula toGLP(GLPTerm model) {
    ArrayList glpFormulae = new ArrayList();
    model = overrideModel(model, this.model, glpFormulae);
    GLogicFormula glpFormula = formula.toGLP(model);
    glpFormula = And.makeGLPConjunction(glpFormulae, glpFormula);
    return new GLPExists(Variable.toGLPVariables(variables), glpFormula);
  }
  
}
