/*
 * Syntax.java
 *
 * Created on February 4, 2002, 4:30 PM
 */

package org.semanticweb.triple.language;

/**
 * Interface for different Triple syntaxes (e.g., PROLOG, native Triple)
 * @author  sintek
 * @version 
 */
public interface Syntax {
  
  String getSymbol(String symbol);
  
  String getVariable(String name);
  
  String getAnd();
  
  String getOr();
  
  String getIf();
  
  String getQueryIf();
  
}

