/*
 * Some.java
 *
 * Created on February 18, 2002, 2:54 PM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 *
 * @author  Michael Sintek
 * @version 
 */
public class Some extends Expression {

  Expression _expr1, _expr2;
  
  /** Creates new Some */
  public Some(Expression expr1, Expression expr2) {
    _expr1 = expr1;
    _expr2 = expr2;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<SOME>");
      _expr1.print (syntax, out);
      _expr2.print (syntax, out);
      out.print ("</SOME>");
    } else {
      out.print ("(some ");
      _expr1.print (syntax, out);
      out.print (" ");
      _expr2.print (syntax, out);
      out.print (")");
    }
  }
  
  public Expression toSHIQ(KB kb, int mode) {
    return new Some(_expr1.toSHIQ(kb, ROLE), _expr2.toSHIQ(kb, CONCEPT));
  }

}
