package org.semanticweb.glp;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

/**
 *  Title: Triple Description: RDF Query and Inference Language Copyright:
 *  Copyright (c) 2001 Company: Stanford University
 *
 *@author     Stefan Decker
 *@created    January 17, 2002
 *@version    1.0
 */

public abstract class GLogicFormula extends GLPExpression {

    /**
     *  Constructor for the GLogicFormula object
     */
    public GLogicFormula() { }


    /**
     *  Description of the Method
     *
     *@param  l   Description of the Parameter
     *@param  Op  Description of the Parameter
     *@param  r   Description of the Parameter
     *@return     Description of the Return Value
     */

    /**
     *  Description of the Method
     *
     *@param  h  Description of the Parameter
     *@return    Description of the Return Value
     */
    public abstract GLogicFormula copyFormula(HashMap h);

    public abstract void renameVariables(HashMap h);


    /**
     *  Description of the Method
     *
     *@param  free   Description of the Parameter
     *@param  bound  Description of the Parameter
     */
    public abstract void freeBoundVariables(HashSet free, HashSet bound);


   public ArrayList getVariables(){
    System.out.println("Abstract methode getVariables in GLogicFormula called");
    return null;
   }
}
