package org.semanticweb.lp;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class StringTerm extends Term {
    String content;


    /**
     *  Constructor for the StringTerm object
     *
     *@param  content  Description of the Parameter
     */
    public StringTerm(String content) {
        this.content = content;
    }


    /**
     *  Gets the content attribute of the StringTerm object
     *
     *@return    The content value
     */
    public String getContent() {
        return content;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        return "StringTerm:" + "\"" + content + "\"";
    }
}
