package org.semanticweb.triple.inference;

/*
 *  Name: Fact.java
 *  Version: 1.0
 *  Purpose:
 *  History:
 */
import java.io.*;
import java.util.*;
import java.net.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class Fact {
    /**
     *  Description of the Field
     */
    public int symbol;
    /**
     *  Description of the Field
     */
    public Term terms[];


    /**
     *  Constructor for the Fact object
     *
     *@param  sym  Description of the Parameter
     *@param  ts   Description of the Parameter
     */
    public Fact(int sym, Term ts[]) {
        terms = ts;
        symbol = sym;
    }


    /**
     *  Description of the Method
     *
     *@param  p  Description of the Parameter
     */
    public void print(PrintStream p) {
        int i;
        p.print("p");
        p.print(symbol);
        p.print("(");
        for (i = 0; i < terms.length; i++) {
            terms[i].print(p);
            if (i < terms.length - 1) {
                p.print(",");
            }
        }
        p.print(").");
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        String s;
        int i;
        s = "p" + Integer.toString(symbol) + "(";
        for (i = 0; i < terms.length; i++) {
            s += terms[i].toString();
            if (i < terms.length - 1) {
                s += ",";
            }
        }
        s += ").";
        return s;
    }
}
