package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


// how do we handle integers in RDF version???

public class IntegerTerm extends Term {

  int value;

  public IntegerTerm () {}

  public IntegerTerm (int value) {
    this.value = value;
  }

  // public void putValue(String ...) { this.name = name; }

  public int getValue() { return value; }


  public String toString(Syntax syntax) {
    return ""+value;
  }

  public GLPTerm toGLP(GLPTerm glpModel, ArrayList glpFormulae) {
    return new GLPTermInteger(new Integer(value));
  }
  
}
